<template>
  <v-app v-if="!checkLogin && updateData">
    <signIn @login="getProfile"></signIn>
  </v-app>
  <v-app color="primary" v-else-if="checkLogin && updateData">
    <v-navigation-drawer color="primary" v-model="drawer" :mini-variant="miniVariant" :clipped="clipped" fixed app >
      <v-list>
        <v-list-item color="white" v-for="(item, i) in items" :key="i" :to="item.to"
                     @click="topicName = item.title"
                     router exact>
          <v-list-item-action>
            <v-icon color="white">{{ item.icon }}</v-icon>
          </v-list-item-action>
          <v-list-item-content>
            <v-list-item-title class="color" v-text="item.title"/>
          </v-list-item-content>
        </v-list-item>
      </v-list>
    </v-navigation-drawer>
    <v-app-bar color="primary" :clipped-left="clipped" fixed app>
      <v-app-bar-nav-icon color="white" @click.stop="drawer = !drawer" />
      <v-btn color="white" icon @click.stop="miniVariant = !miniVariant">
        <v-icon>mdi-{{ `chevron-${miniVariant ? 'right' : 'left'}` }}</v-icon>
      </v-btn>
      <v-btn color="white" icon @click.stop="clipped = !clipped">
        <v-icon>mdi-application</v-icon>
      </v-btn>
      <v-toolbar-title class="color" v-text="title" />
      <v-spacer></v-spacer>
      <v-toolbar-title class="color mr-5" v-text="profile.email" />
      <v-btn width="150px" height="40px" color="red" dark :loading="loadingBeforeSignOut" @click="signOut">sign out</v-btn>
    </v-app-bar>
    <v-content class="content-box">
      <v-banner class="topic-page"> {{topicName}} </v-banner>
      <v-container>
        <nuxt />
      </v-container>
    </v-content>
  </v-app>
</template>

<script>
import signIn from "~/components/signIn";
import menuList from './menuList.json'
import { mapActions } from 'vuex'
import firebase from "firebase";
import 'firebase/auth';

export default {
  name: 'FillgoodWebAdmin',
  components: {
    signIn
  },
  mounted() {
    this.getProfile()
  },
  data() {
    return {
      updateData: false,
      checkLogin: '',
      profile: '',
      items: menuList,
      topicName: '',
      clipped: false,
      drawer: true,
      fixed: false,
      miniVariant: false,
      right: true,
      rightDrawer: false,
      loadingBeforeSignOut: false,
      title: 'Fillgoods (Internal website)'
    }
  },
  methods: {
    ...mapActions({
      clearProfile: 'setSignOut'
    }),
    getProfile(loginValue) {
      const vm = this
      if (loginValue) {
        vm.checkLogin = loginValue.isLogin
        vm.profile = loginValue.profile
      } else {
        vm.checkLogin = (Object.keys(vm.$store.getters['auth/getProfile']).length > 0)
        vm.profile = vm.$store.getters['auth/getProfile']
      }
      vm.checkTopicName()
      vm.updateData = true
    },
    checkTopicName() {
      const vm = this
      vm.topicName = vm.items.find(e => e.to === vm.$router.currentRoute.path).title
    },
    signOut() {
      const vm = this
      const auth = firebase.auth()
      auth.signOut()
        .then(() => {
          vm.$nextTick(() => {
            vm.$nuxt.$router.push('/')
            vm.getProfile()
          })
        })
        .catch((e) => {
          vm.showAlert({ title: 'ระบบขัดข้อง!',
            text: e.middle, type: 'warning',
            time: 5, autoClose: true, show: true })
        })
    }
  }
};
</script>

<style lang="scss" scoped>
  .color {
    color: white;
  }
  .topic-page {
    font-weight: bold;
    padding: 30px;
  }
  .container {
    padding: 30px;
  }
</style>

<style>
  html {
    font-family: Kanit, sans-serif;
    font-size: 16px;
    word-spacing: 1px;
    -ms-text-size-adjust: 100%;
    -webkit-text-size-adjust: 100%;
    -moz-osx-font-smoothing: grayscale;
    -webkit-font-smoothing: antialiased;
    box-sizing: border-box;
    overflow-x: hidden;
    overflow-y: auto;
  }

  *,
  *:before,
  *:after {
    box-sizing: border-box;
    margin: 0;
  }
</style>
